﻿

Procedure shuffleThread(parameter)
	Define timer = ElapsedMilliseconds()
	Define c, count
	Define dice
	If dFloor = 1	:	MouseLocate(Random(#xRes),Random(#yRes))	:	EndIf
	
	endShuffle = #False
	shuffleDelay = parameter
	Repeat
		count = 0
		ExamineMouse()
		If Mod(MouseX(),2) = 0			:	count +1	:	EndIf
		If Mod(MouseY(),2) = 0			:	count +2	:	EndIf
		If Mod(ElapsedMilliseconds(),2)	:	count +4	:	EndIf
		
		For c = 0 To count
			dice = Random(1)
		Next
		Delay(shuffleDelay)
	Until endShuffle
EndProcedure




Procedure createDungeon()
	If wizMode(#wizShuffleSeed)	:	CreateThread(@shuffleThread(),0)	:	EndIf
	
	Define eachCount, parentLoop
	Define noError, nothingFound
	Define low, high
	Define count, countTiles, maxDoor
	Define a, b
	Define x, y
	Define xShift, yShift
	Define xLoc, yLoc
	Define xSize, ySize
	Define dir, d
	Define legit
	Define countRoom = #firstRoomIndex
	Define *doorPointer.POINT_XY
	Define *thisActor.ACTOR
	Define corridor
	Define dice
	Dim xPortal(1)
	Dim yPortal(1)
	Dim xPortalTarget(1)
	Dim yPortalTarget(1)
	Dim placementMatrix(0,0)
	Define xDivideKey, yDivideKey, divideDoorIndex
	xDivide = 0
	yDivide = 0
	maxInstance = 0
	Dim bombValue(0)	

	Define style = Random(3,1)
	Define styleCount = Random(style)
	Define dungeonSize = Random(6,5)+(weightedRoll(1,4,16,64,16,4,1,0,0,0)*Random(2,1) )
	Define divisionChance = Random(100)
	Define doorPercent = Random(66,16)
	Define maxLoop = Random(dungeonSize/Random(3,2),Random(2,1))
	Define loopLength = gaussRoll(6,20,#False)
	Define ragged1 = Random(12)
	Define ragged2 = Random(12)
	Define bombMin = 5
	Define bombMax = 70
	Define lockedPercent = Random(75,40)
	monsterMax = dungeonSize*2
	itemMax = dungeonSize*2
	
	ClearList(blackShoppingList())
	ClearList(whiteShoppingList())	
	
	
	progressBar(63,1)
	

	;{ BASIC ARCHITECTURE
	progressBar(0,1)
	dungeonFill = 0
	x = Random(xMax-12,2)
	y = Random(yMax-12,2)
	xSize = Random(10,3)
	ySize = Random(10,3)
	carveRoom(x,y,xSize,ySize,countRoom)
	translateFloor()
	
	a = 10
	Repeat
		Repeat
			xLoc = Random(xMax-12,2)
			yLoc = Random(yMax-12,2)
		Until floorMap(xLoc,yLoc) > 1
		
		styleCount +1
		If styleCount > style
			styleCount = 0
		EndIf		
		
		Select styleCount
			Case 1, 2
				corridor = #False
				xSize = Random(10,2)
				ySize = Random(10,2)
				
			Case 0
				corridor = #True
				If Random(1) = 0
					xSize = Random(9,4)
					ySize = 1
				Else
					xSize = 1
					ySize = Random(9,4)
				EndIf
		EndSelect

		ClearList(chooseDirection())
		For dir = 1 To 4
			xShift = xLoc
			yShift = yLoc
			Repeat
				xShift + xMod(dir)
				yShift + yMod(dir)
				legit = #True
				
				For x = xShift-1 To xShift+xSize
					For y = yShift-1 To yShift+ySize
						If floorMap(limit(x,0,xMax),limit(y,0,yMax)) > 0
							legit = #False
							Break 2
						EndIf
					Next
				Next
				If Not legit
					Continue
				EndIf
				
				If xShift > 2 And xShift+xSize-1 < xMax-2 And yShift > 2 And yShift+ySize-1 < yMax-2
					ClearList(node())
					For count = 1 To 4
						AddElement(node())
						node()\value = count
					Next
					
					Repeat
						SelectElement(node(),Random(ListSize(node()),1)-1)
						Select node()\value
							Case 1
								For x = xShift To xShift+xSize-1
									If floorMap(x,yShift+ySize+1) > #doorIndex
										legit = 1
										Break 3
									EndIf
								Next
							Case 2
								For y = yShift To yShift+ySize-1
									If floorMap(xShift+xSize+1,y) > #doorIndex
										legit = 2
										Break 3
									EndIf
								Next
							Case 3
								For y = yShift To yShift+ySize-1
									If floorMap(xShift-2,y) > #doorIndex
										legit = 3
										Break 3
									EndIf
								Next
							Case 4
								For x = xShift To xShift+xSize-1
									If floorMap(x,yShift-2) > #doorIndex
										legit = 4
										Break 3
									EndIf
								Next
						EndSelect
						DeleteElement(node())
					Until ListSize(node()) = #Null
				Else
					legit = #False
					Break
				EndIf
				
			ForEver

			If legit
				AddElement(chooseDirection())
				chooseDirection()\x = xShift
				chooseDirection()\y = yShift
				chooseDirection()\val[0] = legit
				chooseDirection()\val[1] = xSize
				chooseDirection()\val[2] = ySize
			EndIf

		Next

		If ListSize(chooseDirection()) <> #Null
			SelectElement(chooseDirection(),Random(ListSize(chooseDirection()),1)-1)
			countRoom +1
			If (corridor And Mod(countRoom,2) > 0) Or ((Not corridor) And Mod(countRoom,2) = 0)
				countRoom +1
			EndIf
			carveRoom(chooseDirection()\x,chooseDirection()\y,chooseDirection()\val[1],chooseDirection()\val[2],countRoom)

			Repeat
				Select chooseDirection()\val[0]
					Case 1
						x = Random(chooseDirection()\x+chooseDirection()\val[1] - 1, chooseDirection()\x)
						y = chooseDirection()\y+chooseDirection()\val[2]
					Case 2
						x = chooseDirection()\x+chooseDirection()\val[1]
						y = Random(chooseDirection()\y+chooseDirection()\val[2] - 1, chooseDirection()\y)
					Case 3
						x = chooseDirection()\x-1
						y = Random(chooseDirection()\y+chooseDirection()\val[2] - 1, chooseDirection()\y)
					Case 4
						x = Random(chooseDirection()\x+chooseDirection()\val[1] - 1, chooseDirection()\x)
						y = chooseDirection()\y-1
				EndSelect
			Until floorMap(x+xOpp(chooseDirection()\val[0]),y+yOpp(chooseDirection()\val[0])) > #doorIndex
			carveRoom(x,y,1,1,#doorIndex)
		EndIf

		If dungeonFill >= ((dungeonSize*xMax*yMax)/100)/a
			progressBar(0,1)
			a -1
			If wizMode(#wizShuffleSeed)	:	Delay(100)	:	EndIf
		EndIf
		Delay(1)
	Until dungeonFill >= (dungeonSize*xMax*yMax)/100
	translateFloor()
	;}
	
	;{ COUNT DOORS
	progressBar(0,1)
	maxDoor = 0
	ForEach freeField()
		If freeField()\value = #doorIndex
			maxdoor +1
		EndIf
	Next
	;}

	fixDeadEnds()

	;{ REMOVE CORRIDOR-DOORS
	progressBar(0,1)
	Repeat
		noError = #True
		ForEach freeField()
			If freeField()\value = #doorIndex
				count = 0
				For dir = 1 To 2
					If floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) > 0
						If Mod(floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir)),2) = 0 And Mod(floorMap(freeField()\x+xOpp(dir),freeField()\y+yOpp(dir)),2) = 0
							floorMap(freeField()\x,freeField()\y) = floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir))
							noError = #False
							Break 2
						EndIf
					EndIf
				Next
			EndIf
		Next
		
		translateFloor()
	Until noError
	progressBar(0,1)
	homogenizeRoomIndex()
	;}
	
	;{ REMOVE DOUBLE DOORS FROM CORRIDORS
	progressBar(0,1)
	Repeat
		noError = #True
		ClearList(node())
		ForEach	freeField()
			If freeField()\value = #doorIndex
				For dir = 1 To 4
					If floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) > 0 And Mod(floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir)),2) = 0
						AddElement(node())
						node()\x = freeField()\x
						node()\y = freeField()\y
						node()\value = floorMap(node()\x+xMod(dir),node()\y+yMod(dir))
						Break
					EndIf
				Next
			EndIf
		Next
		While ListSize(node()) <> #Null
			ClearList(pickTile())
			*doorPointer = #Null
			If FirstElement(node())
				*doorPointer = @node()
				AddElement(pickTile())
				pickTile()\x = *doorPointer\x
				pickTile()\y = *doorPointer\y
				ForEach node()
					If (Not (node()\x = *doorPointer\x And node()\y = *doorPointer\y)) And node()\value =  *doorPointer\value
						AddElement(pickTile())
						pickTile()\x = node()\x
						pickTile()\y = node()\y
					EndIf
				Next
				If ListSize(pickTile()) > 1
					noError = #False
					SelectElement(pickTile(),Random(ListSize(pickTile()),1)-1)
					linkRooms()
					Break
				EndIf
			EndIf
			ChangeCurrentElement(node(),*doorPointer)
			DeleteElement(node())
		Wend
		homogenizeRoomIndex()
	Until noError
	;}

	floodFillDungeon()

	;{ FIND LOOPS
	progressBar(0,1)
	count = 0
	Dim lastTile(dungeonSize)
	Repeat
		If maxLoop = 0
			Continue
		EndIf
		
		ClearList(chooseDirection())
		ForEach freeField()
			If freeField()\value > #doorIndex
				For dir = 1 To 4
					If floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) = 0
						AddElement(chooseDirection())
						chooseDirection()\x = freeField()\x
						chooseDirection()\y = freeField()\y
						chooseDirection()\value = dir
					EndIf
				Next
			EndIf
		Next
		While ListSize(chooseDirection()) <> #Null
			SelectElement(chooseDirection(),Random(ListSize(chooseDirection()),1)-1)
			
			If floorMap(freeField()\x+xMod(chooseDirection()\value),freeField()\y+yMod(chooseDirection()\value)) = 0
				xShift = chooseDirection()\x
				yShift = chooseDirection()\y
				legit = #True
				countTiles = 0
				Repeat
					countTiles +1
					xShift + xMod(chooseDirection()\value)
					yShift + yMod(chooseDirection()\value)
					
					Select chooseDirection()\value
						Case 1, 4
							If floorMap(xShift-1,yShift) > 0 Or floorMap(xShift+1,yShift) > 0
								legit = #False
							EndIf
						Case 2, 3
							If floorMap(xShift,yShift-1) > 0 Or floorMap(xShift,yShift+1) > 0
								legit = #False
							EndIf
					EndSelect
					
					If floorMap(xShift,yShift) > #doorIndex
						legit = #True
						Break
					EndIf
					
					If xShift < 2 Or xShift > xMax-1 Or yShift < 2 Or yShift > yMax-1 
						legit = #False
					EndIf
					
				Until legit = #False
				
				If legit And countTiles <= loopLength And floorMap(chooseDirection()\x,chooseDirection()\y) <> floorMap(xShift,yShift)
					If getPath(chooseDirection()\x,chooseDirection()\y,xShift,yShift,#Null,#True) >= (dungeonSize*2)
						xShift = chooseDirection()\x
						yShift = chooseDirection()\y
						Repeat
							xShift + xMod(chooseDirection()\value)
							yShift + yMod(chooseDirection()\value)
							floorMap(xShift,yShift) = #firstRoomIndex
						Until floorMap(xShift+xMod(chooseDirection()\value),yShift+yMod(chooseDirection()\value)) > #doorIndex
						
						noError = #True
						For dir = 1 To 8
							If floorMap(((chooseDirection()\x+xShift)/2)+xMod(dir),((chooseDirection()\y+yShift)/2)+yMod(dir)) = #doorIndex
								noError = #False
								DeleteElement(chooseDirection())	
								Break
							EndIf
						Next
						If noError And countTiles > 2
							floorMap((chooseDirection()\x+xShift)/2,(chooseDirection()\y+yShift)/2) = #doorIndex
						EndIf
						
						count +1
						DeleteElement(chooseDirection())
						Break
					EndIf
				EndIf
			EndIf
		
			DeleteElement(chooseDirection())
		Wend
		
		homogenizeRoomIndex()
;		translateFloor()
	
		If ListSize(chooseDirection()) = #Null
			Break
		EndIf
	Until count = maxLoop
	;}

	;{ REDUCE DOORS	
	progressBar(0,1)
	ClearList(pickTile())
	ForEach freeField()
		If floorMap(freeField()\x,freeField()\y) = #doorIndex
			AddElement(pickTile())
			pickTile()\x = freeField()\x
			pickTile()\y = freeField()\y
		EndIf
	Next
	While ListSize(pickTile()) > (maxDoor*doorPercent)/100
		SelectElement(pickTile(),Random(ListSize(pickTile()),1)-1)
		linkRooms()
		DeleteElement(pickTile())
	Wend
	;}		
	
	;{ REMOVE OBSOLETE DOORS
	progressBar(0,1)
	Repeat
		legit = #True
		ForEach freeField()
			If freeField()\value = #doorIndex
				collisionMap(freeField()\x,freeField()\y) = 1
			EndIf
		Next
		ForEach freeField()
			If freeField()\value = #doorIndex
				For dir = 1 To 2
					If floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) > 0
						If getPath(freeField()\x+xMod(dir),freeField()\y+yMod(dir),freeField()\x+xOpp(dir),freeField()\y+yOpp(dir),#Null,#False)
							legit = #False
							Break
						EndIf
					EndIf
				Next
				If Not legit
					ClearList(pickTile())
					AddElement(pickTile())
					pickTile()\x = freeField()\x
					pickTile()\y = freeField()\y
					linkRooms()
				EndIf
			EndIf
		Next
	Until legit
	translateFloor()
	;}
	
	;{ REMOVE SINGLE WALLS
	progressBar(0,1)
	For x = 2 To xMax-2
		For y = 2 To yMax-2
			If floorMap(x,y) = 0
				count = 0
				For dir = 1 To 4
					If floorMap(x+xMod(dir),y+yMod(dir)) > #doorIndex
						count +1
					EndIf
				Next
				If count = 4
					floorMap(x,y) = floorMap(x+xMod(dir),y+yMod(dir))
				EndIf
			EndIf
		Next
	Next
	translateFloor()
	;}

	;{ RAGGED ROOM CORNERS
	For count = 3 To 1 Step -1
		progressBar(0,1)
		dice = Pow(count,2)*ragged1
		ClearList(node())
		For x = 2 To xMax-2
			For y = 2 To yMax-2
				If floorMap(x,y) = 0
					For dir = 5 To 8
						If floorMap(x+xMod(dir),y+yMod(dir)) > #doorIndex And
								floorMap(x+xMod(dir)+xSide(dir,1),y+yMod(dir)+ySide(dir,1))> #doorIndex And floorMap(x+xMod(dir)+xSide(dir,2),y+yMod(dir)+ySide(dir,2)) > #doorIndex And
								floorMap(x+xSide(dir,1),y+ySide(dir,1)) = 0 And floorMap(x+xSide(dir,2),y+ySide(dir,2)) = 0 And
								floorMap(x+xOpp(dir),y+yOpp(dir)) = 0 And floorMap(x+(xOpp(dir)*2),y+(yOpp(dir)*2)) = 0
							AddElement(node())
							node()\x = x
							node()\y = y
							Break
						EndIf
					Next
				EndIf
			Next
		Next
		While ListSize(node()) <> #Null
			SelectElement(node(),Random(ListSize(node()),1)-1)
			If Random(100,1) <= dice
				floorMap(node()\x,node()\y) = #firstRoomIndex
			EndIf
			DeleteElement(node())
		Wend
		translateFloor()
	Next

	For count = 3 To 1 Step -1
		progressBar(0,1)
		dice = Pow(count,2)*ragged2
		ClearList(node())
		ForEach freeField()
			If floorMap(freeField()\x,freeField()\y) > #doorIndex
				For dir = 5 To 8
					If floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) = 0 And
					   floorMap(freeField()\x+xMod(dir)+xSide(dir,1),freeField()\y+yMod(dir)+ySide(dir,1)) = 0 And floorMap(freeField()\x+xMod(dir)+xSide(dir,2),freeField()\y+yMod(dir)+ySide(dir,2)) = 0 And
					   floorMap(freeField()\x+xSide(dir,1),freeField()\y+ySide(dir,1)) > #doorIndex And floorMap(freeField()\x+xSide(dir,2),freeField()\y+ySide(dir,2)) > #doorIndex And
					   floorMap(freeField()\x+xOpp(dir),freeField()\y+yOpp(dir)) > #doorIndex And floorMap(freeField()\x+(xOpp(dir)*2),freeField()\y+(yOpp(dir)*2)) > #doorIndex
							AddElement(node())
							node()\x = freeField()\x
							node()\y = freeField()\y
					EndIf
				Next
			EndIf
		Next

		While ListSize(node()) <> #Null
			SelectElement(node(),Random(ListSize(node()),1)-1)
			If Random(100,1) <= dice
				floorMap(node()\x,node()\y) = 0
			EndIf
			DeleteElement(node())
		Wend
		translateFloor()
	Next
	;}

	fixDeadEnds()
	
	;{ HAUL DUNGEON
	progressBar(0,1)
	Dim floorMap(#xMax,#yMax)
	x = #xMax
	y = #yMax
	ForEach freeField()
		If freeField()\x < x
			x = freeField()\x
		EndIf
		If freeField()\y < y
			y = freeField()\y
		EndIf
	Next
	x = x-2
	y = y-2
	ForEach freeField()
		freeField()\x -x
		freeField()\y -y
		floorMap(freeField()\x,freeField()\y) = freeField()\value
	Next
	translateFloor()
	;}
	
	floodFillDungeon()

	;{ INNER ARCHITECTURE
	progressBar(0,1)
	Repeat
		nothingFound = #True
		ClearList(pickTile())
		ForEach freeField()
			legit = #False
			For dir = 1 To 4
				If floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) > #doorIndex And floorMap(freeField()\x+xOpp(dir),freeField()\y+yOpp(dir)) = 0 And
					   floorMap(freeField()\x+xSide(dir,1),freeField()\y+ySide(dir,1)) > #doorIndex And floorMap(freeField()\x+xSide(dir,2),freeField()\y+ySide(dir,2)) > #doorIndex And
					   floorMap(freeField()\x+xMod(dir)+xSide(dir,1),freeField()\y+yMod(dir)+ySide(dir,1)) > #doorIndex And floorMap(freeField()\x+xMod(dir)+xSide(dir,2),freeField()\y+yMod(dir)+ySide(dir,2)) > #doorIndex
					legit = #True
					nothingFound = #False
				EndIf
			Next
			If legit
				AddElement(pickTile())
				pickTile()\x = freeField()\x
				pickTile()\y = freeField()\y
			EndIf
		Next
		If ListSize(pickTile()) <> #Null
			SelectElement(pickTile(), Random(ListSize(pickTile()),1)-1)
			x = pickTile()\x
			y = pickTile()\y
			ClearList(pickTile())
			AddElement(pickTile())
			pickTile()\x = x
			pickTile()\y = y
			AddElement(blackShoppingList())
			blackShoppingList()\x = x
			blackShoppingList()\y = y
			blackShoppingList()\value = floorMap(x,y)
			floorMap(x,y) = 0
		EndIf
			
		While ListSize(pickTile()) <> #Null
			SelectElement(pickTile(), Random(ListSize(pickTile()),1)-1)
			
			ClearList(saveTile())
			For dir = 1 To 4
				If floorMap(pickTile()\x+(xMod(dir)*2),pickTile()\y+(yMod(dir)*2)) > #doorIndex
					If floorMap(pickTile()\x+xMod(dir)+xSide(dir,1),pickTile()\y+yMod(dir)+ySide(dir,1)) > #doorIndex And floorMap(pickTile()\x+xMod(dir)+xSide(dir,2),pickTile()\y+yMod(dir)+ySide(dir,2)) > #doorIndex
						If floorMap(pickTile()\x+(xMod(dir)*2)+xSide(dir,1),pickTile()\y+(yMod(dir)*2)+ySide(dir,1)) > #doorIndex And floorMap(pickTile()\x+(xMod(dir)*2)+xSide(dir,2),pickTile()\y+(yMod(dir)*2)+ySide(dir,2)) > #doorIndex
							If floorMap(pickTile()\x+xMod(dir),pickTile()\y+yMod(dir)) > #doorIndex
								AddElement(saveTile())
								saveTile()\x = pickTile()\x+xMod(dir)
								saveTile()\y = pickTile()\y+yMod(dir)
							EndIf
						EndIf
					EndIf      
				EndIf
			Next
			
			If ListSize(saveTile()) <> #Null
				SelectElement(saveTile(), Random(ListSize(saveTile()),1)-1)
				AddElement(pickTile())
				pickTile()\x = saveTile()\x
				pickTile()\y = saveTile()\y
				AddElement(blackShoppingList())
				blackShoppingList()\x = pickTile()\x
				blackShoppingList()\y = pickTile()\y
				blackShoppingList()\value = floorMap(pickTile()\x,pickTile()\y)
				floorMap(pickTile()\x,pickTile()\y) = 0
			Else
				DeleteElement(pickTile())
			EndIf
		Wend
		translateFloor()
	Until nothingFound		

	;}
	
	;{ BUILD WHITE SHOPPINGLIST
	progressBar(0,1)
	ForEach freeField()
		If freeField()\value > #doorIndex
			legit = #True
			For dir = 1 To 8
				If floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) = #doorIndex
					legit = #False
					Break
				EndIf
			Next
			If legit
				AddElement(whiteShoppingList())
				whiteShoppingList()\x = freeField()\x
				whiteShoppingList()\y = freeField()\y
				whiteShoppingList()\value = freeField()\value
			EndIf
		EndIf
	Next
	;}

	;{ BOMB WALLS
	progressBar(0,1)
	Dim bombValue(maxInstance)
	For count = #firstRoomIndex To maxInstance
		bombValue(count) = Random(bombMax,bombMin)
		ClearList(saveTile())
		ForEach blackShoppingList()
			If blackShoppingList()\value = count
				AddElement(saveTile())
				saveTile()\x = blackShoppingList()\x
				saveTile()\y = blackShoppingList()\y
			EndIf
		Next
		countTiles = ListSize(saveTile())
		While ListSize(saveTile()) > (bombValue(count)*countTiles)/100
			SelectElement(saveTile(),Random(ListSize(saveTile()),1)-1)
			floorMap(saveTile()\x,saveTile()\y) = count
			DeleteElement(saveTile())
		Wend
	Next
	;}
	
	;{ FINALIZE BLACK SHOPPINGLIST
	progressBar(0,1)
	ForEach blackShoppingList()
		For dir = 5 To 8
			If floorMap(blackShoppingList()\x+xMod(dir),blackShoppingList()\y+yMod(dir)) = 0 And
					floorMap(blackShoppingList()\x+xMod(dir)+xSide(dir,1),blackShoppingList()\y+yMod(dir)+ySide(dir,1)) > #doorIndex And
					floorMap(blackShoppingList()\x+xMod(dir)+xSide(dir,2),blackShoppingList()\y+yMod(dir)+ySide(dir,2)) > #doorIndex
				floorMap(blackShoppingList()\x,blackShoppingList()\y) = blackShoppingList()\value
			EndIf
		Next
	Next
	ForEach blackShoppingList()
		count = 0
		For dir = 1 To 8
			If floorMap(blackShoppingList()\x+xMod(dir),blackShoppingList()\y+yMod(dir)) > #doorIndex
				count +1
			EndIf
		Next
		If count = 8
			floorMap(blackShoppingList()\x,blackShoppingList()\y) = blackShoppingList()\value
		EndIf
	Next
	ForEach blackShoppingList()
		If floorMap(blackShoppingList()\x,blackShoppingList()\y) = 0
			DeleteElement(blackShoppingList())
		EndIf
	Next
	translateFloor()
	;}
	
	;{ REFACTOR BORDERS
	progressBar(0,1)
	x = 0
	y = 0
	ForEach freeField()
		If freeField()\x > x
			x = freeField()\x
		EndIf
		If freeField()\y > y
			y = freeField()\y
		EndIf
	Next
	xMax = x+2
	yMax = y+2
	clearFloor(xMax,yMax)
	ForEach freeField()
		floorMap(freeField()\x,freeField()\y) = freeField()\value
	Next
	translateFloor()
	;}	

	;{ DIVIDE DUNGEON
	progressBar(0,1)
	If Random(100,1) <= divisionChance
		ClearList(pickTile())
		ForEach freeField()
			If freeField()\value = #doorIndex ;Alle Türfelder markieren (wenn oneWay-Door)
				collisionMap(freeField()\x,freeField()\y) = 1
				For dir = 1 To 2
					If floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) > 0
						If Not (getPath(freeField()\x+xMod(dir),freeField()\y+yMod(dir),freeField()\x+xOpp(dir),freeField()\y+yOpp(dir),#Null,#True)) And
						   (Not detectDeadEnd(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) And Not detectDeadEnd(freeField()\x+xOpp(dir),freeField()\y+yOpp(dir))  )
							AddElement(pickTile())
							pickTile()\x = freeField()\x
							pickTile()\y = freeField()\y
							Break
						EndIf
					EndIf
				Next
				collisionMap(freeField()\x,freeField()\y) = 0
			EndIf
		Next
		ForEach pickTile()
			Dim bresenRef(xMax,yMax)	;Platzhalter für virtuelle floorMap
			ForEach freeField()
				bresenRef(freeField()\x,freeField()\y) = -1	;alle freien Felder (außer gewähltes Türfeld) mit -1 initialisieren
			Next
			bresenRef(pickTile()\x,pickTile()\y) = 0
			For dir = 1 To 2
				If bresenRef(pickTile()\x+xMod(dir),pickTile()\y+yMod(dir)) = -1 ;Beide Türseiten unterschiedlich initialisieren
					bresenRef(pickTile()\x+xMod(dir),pickTile()\y+yMod(dir)) = 1
					bresenRef(pickTile()\x+xOpp(dir),pickTile()\y+yOpp(dir)) = 2
					Break
				EndIf
			Next
			
			;FloodFill
			Repeat
				noError = #True
				ForEach freeField()
					If bresenRef(freeField()\x,freeField()\y) > 0
						For dir = 1 To 4
							If bresenRef(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) = -1
								bresenRef(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) = bresenRef(freeField()\x,freeField()\y)
								noError = #False
							EndIf
						Next
					EndIf
				Next
			Until noError
			
			;Verhältnis beider Seiten abgleichen
			ForEach	freeField()
				For count = 1 To 2
					If bresenRef(freeField()\x,freeField()\y) = count
						pickTile()\val[count] +1
					EndIf
				Next
			Next
		Next
		If ListSize(pickTile()) > #Null
			ForEach pickTile()
				If pickTile()\val[1] < pickTile()\val[2]
					low = (pickTile()\val[1]*100)/pickTile()\val[2]
				Else
					low = (pickTile()\val[2]*100)/pickTile()\val[1]
				EndIf
				If low < 15
					DeleteElement(pickTile())
				EndIf
			Next
			If ListSize(pickTile()) > #Null
				SelectElement(pickTile(),Random(ListSize(pickTile()),1)-1)			
				xDivide = pickTile()\x
				yDivide = pickTile()\y
			EndIf
		EndIf
		translateFloor()
	EndIf
	;}	
	
	
	;Startfeld
	progressBar(0,1)
	If Not *activeTeleport
		pickShopItem(255,#True)
		xPlayer = shopX
		yPlayer = shopY
	EndIf

	;{ DISTRIBUTE EXITS
	For dir = 1 To 4
		progressBar(0,1)
		ClearList(pickTile())
		Select dir
				;{ Norden
			Case 1
				ForEach freeField()
					legit = #True
					ForEach blackShoppingList()
						If freeField()\x = blackShoppingList()\x And freeField()\y = blackShoppingList()\y
							legit = #False
							Break
						EndIf
					Next
					If legit
						If freeField()\value <> #doorIndex
							legit = #True
							For d = -1 To 1
								If floorMap(freeField()\x+d,freeField()\y-1) > 0 Or floorMap(freeField()\x+d,freeField()\y-2) > 0
									legit = #False
									Break
								EndIf
							Next
							If legit
								For y = freeField()\y-1 To 0 Step -1
									If floorMap(freeField()\x,y) > 0 
										legit = #False
										Break
									EndIf
								Next
								If legit
									AddElement(pickTile())
									pickTile()\x = freeField()\x
									pickTile()\y = freeField()\y-1
								EndIf
							EndIf
						EndIf
					EndIf
				Next
				;}
				
				;{ Westen
			Case 2
				ForEach freeField()
					legit = #True
					ForEach blackShoppingList()
						If freeField()\x = blackShoppingList()\x And freeField()\y = blackShoppingList()\y
							legit = #False
							Break
						EndIf
					Next
					If legit
						If freeField()\value <> #doorIndex
							legit = #True
							For d = -1 To 1
								If floorMap(freeField()\x-1,freeField()\y+d) > 0 Or floorMap(freeField()\x-2,freeField()\y+d) > 0
									legit = #False
									Break
								EndIf
							Next
							If legit
								For x = freeField()\x-1 To 0 Step -1
									If floorMap(x,freeField()\y) > 0
										legit = #False
										Break
									EndIf
								Next
								If legit
									AddElement(pickTile())
									pickTile()\x = freeField()\x-1
									pickTile()\y = freeField()\y
								EndIf
							EndIf
						EndIf
					EndIf
				Next
				;}
				
				;{ Osten
			Case 3
				ForEach freeField()
					legit = #True
					ForEach blackShoppingList()
						If freeField()\x = blackShoppingList()\x And freeField()\y = blackShoppingList()\y
							legit = #False
							Break
						EndIf
					Next
					If legit
						If freeField()\value <> #doorIndex
							legit = #True
							For d = -1 To 1
								If floorMap(freeField()\x+1,freeField()\y+d) > 0 Or floorMap(freeField()\x+2,freeField()\y+d) > 0
									legit = #False
									Break
								EndIf
							Next
							If legit
								For x = freeField()\x+1 To xMax
									If floorMap(x,freeField()\y) > 0
										legit = #False
										Break
									EndIf
								Next
								If legit
									AddElement(pickTile())
									pickTile()\x = freeField()\x+1
									pickTile()\y = freeField()\y
								EndIf
							EndIf
						EndIf
					EndIf
				Next
				;}
				
				;{ Süden
			Case 4
				ForEach freeField()
					legit = #True
					ForEach blackShoppingList()
						If freeField()\x = blackShoppingList()\x And freeField()\y = blackShoppingList()\y
							legit = #False
							Break
						EndIf
					Next
					If legit
						If freeField()\value <> #doorIndex
							legit = #True
							For d = -1 To 1
								If floorMap(freeField()\x+d,freeField()\y+1) > 0 Or floorMap(freeField()\x+d,freeField()\y+2) > 0
									legit = #False
									Break
								EndIf
							Next
							If legit
								For y = freeField()\y+1 To yMax
									If floorMap(freeField()\x,y) > 0
										legit = #False
										Break
									EndIf
								Next
								If legit
									AddElement(pickTile())
									pickTile()\x = freeField()\x
									pickTile()\y = freeField()\y+1
								EndIf
							EndIf
						EndIf
					EndIf
				Next
				;}
				
		EndSelect
		ForEach pickTile()
			If dir = 1 And pickTile()\y > yMax/3
				DeleteElement(pickTile())
			EndIf
			If dir = 2 And pickTile()\x > xMax/3
				DeleteElement(pickTile())
			EndIf
			If dir = 3 And pickTile()\x < xMax-(xMax/3)
				DeleteElement(pickTile())
			EndIf
			If dir = 4 And pickTile()\y < yMax-(yMax/3)
				DeleteElement(pickTile())
			EndIf
		Next
		If ListSize(pickTile())
			SelectElement(pickTile(),Random(ListSize(pickTile()),1)-1)
			floorMap(pickTile()\x,pickTile()\y) = #doorIndex
			translateFloor()
			xExit(dir) = pickTile()\x
			yExit(dir) = pickTile()\y
		Else
			Debug "No legit tiles for placing exit!"
			End
		EndIf
	Next
	If *activeTeleport
		xPlayer = xExit(entryCardinal)
		yPlayer = yExit(entryCardinal)
		createTeleport(#tInvisible,dFloor,xPlayer,yPlayer,*activeTeleport\dFloor[0],*activeTeleport\x[0],*activeTeleport\y[0],#True,-1)
		*activeTeleport\dFloor[1] = dFloor
		*activeTeleport\x[1] = xPlayer
		*activeTeleport\y[1] = yPlayer
	EndIf
	;}
	
	;{ SELECT CARDINAL EXIT
	ClearList(chooseDirection())
	For count = 1 To #maxExit
		progressBar(0,1)
		AddElement(chooseDirection())
		chooseDirection()\x = xExit(count)
		chooseDirection()\y = yExit(count)
		chooseDirection()\value = getPath(xPlayer,yPlayer,xExit(count),yExit(count),#False,#True)
	Next
	low = 0
	ForEach chooseDirection()
		If chooseDirection()\value > low
			low = chooseDirection()\value
		EndIf
	Next
	ForEach chooseDirection()
		If (chooseDirection()\value*100)/low < 40
			DeleteElement(chooseDirection())
		EndIf
	Next
	SelectElement(chooseDirection(),Random(ListSize(chooseDirection()),1)-1)
	xExit(0) = chooseDirection()\x
	yExit(0) = chooseDirection()\y
	;Übrige Exits löschen (nur physisch)!
	For count = 1 To #maxExit
		progressBar(0,1)
		If Not (xExit(0) = xExit(count) And yExit(0) = yExit(count)) And Not (xExit(count) = xPlayer And yExit(count) = yPlayer)
			floorMap(xExit(count),yExit(count)) = 0
		EndIf
	Next
	translateFloor()
	createTeleport(#tInvisible,dFloor,xExit(0),yExit(0),0,0,0,#True,-1)
	;}
	
	;{ LOCK DOORS
	ClearList(saveTile())
	maxDoor = 0
	ForEach freeField()
		If freeField()\value = #doorIndex
			AddElement(saveTile())
			saveTile()\x = freeField()\x
			saveTile()\y = freeField()\y
			maxDoor +1
		EndIf
	Next
	For count = 0 To 4
		progressBar(0,1)
		ForEach saveTile()
			If (saveTile()\x = xExit(count) And saveTile()\y = yExit(count)) ;Or (saveTile()\x = xDivide And saveTile()\y = yDivide)
				DeleteElement(saveTile())
				maxDoor -1
			EndIf
		Next
	Next
	If maxDoor > 0
		Repeat
			SelectElement(saveTile(),Random(ListSize(saveTile()),1)-1)
			DeleteElement(saveTile())
		Until ListSize(saveTile()) <= (lockedPercent*maxDoor)/100
		ForEach saveTile()
			collisionMap(saveTile()\x,saveTile()\y) = 1
		Next
		ForEach	saveTile()
			x = saveTile()\x
			y = saveTile()\y		
			For dir = 1 To 2
				If floorMap(x+xMod(dir),y+yMod(dir)) > #doorIndex
					If getPath(x+xMod(dir),y+yMod(dir),x+xOpp(dir),y+yOpp(dir),#Null,#False)
						collisionMap(x,y) = 0
						DeleteElement(saveTile())
					EndIf
					Break
				EndIf
			Next
		Next
		translateFloor()
	EndIf
	If ListSize(saveTile()) > #Null
		ForEach saveTile()
			collisionMap(saveTile()\x,saveTile()\y) = 1 ;alle Türen schließen
		Next
		
		a = 0		;keyIndex initialisieren (Dokumentation der optimalen Reihenfolge beim Benutzen der Schlüssel)	
		Repeat
			ClearList(pickTile())
			ForEach saveTile() ;offene Liste nach Türen durchsuchen, welche vom Startfeld aus erreichbar sind ...
				If getPath(xPlayer,yPlayer,saveTile()\x,saveTile()\y,#Null,#False)
					AddElement(pickTile())	;... und auf temporäre Liste setzen
					pickTile()\x = saveTile()\x
					pickTile()\y = saveTile()\y
				EndIf
			Next

			a +1  ;keyIndex um 1 erhöhen
			;Tür auswürfeln:
			SelectElement(pickTile(),Random(ListSize(pickTile()),1)-1)
			;gültiges Feld für den Schlüssel finden:	
;			ClearList(restoreTile())
;			ForEach whiteShoppingList()
;				legit = #True
;				For dir = 1 To 8 ;Keine Schlüssel direkt vor Türen
;					If floorMap(whiteShoppingList()\x+xMod(dir),whiteShoppingList()\y+yMod(dir)) = #doorIndex
;						legit = #False
;						Break
;					EndIf
;				Next
;				If legit
;					AddElement(restoreTile())
;					restoreTile()\x = whiteShoppingList()\x
;					restoreTile()\y = whiteShoppingList()\y
;				EndIf
;			Next
			CopyList(whiteShoppingList(),restoreTile())
			Repeat
				SelectElement(restoreTile(),Random(ListSize(restoreTile()),1)-1)
				shopX = restoreTile()\x
				shopY = restoreTile()\y
				If getPath(xPlayer,yPlayer,shopX,shopY,#Null,#False)
					Break
				EndIf
				DeleteElement(restoreTile())
				If ListSize(restoreTile()) = #Null
					Debug "No tiles for key placement left!"
					End
				EndIf
			ForEver
			;Schlüsselfarbe auswürfeln und Item im Dungeon platzieren
			dice = weightedRoll(6,5,4,3,0,0,0,0,0,0)
			createItem(#keyItem,dice,0,0,0,#itemDepth,#selfInteract,0,0)
			;Zielkoordinaten des Schlüssels in temporären dummy-Variablen speichern um bei doorActor()-Creation Türfarbe anzupassen
			actor()\xDummy = pickTile()\x
			actor()\yDummy = pickTile()\y
			actor()\flagDummy = a
			dropItem(@actor(),shopX,shopY)
			;Tür öffnen, Tile freigeben und Element von offener Liste löschen
			collisionMap(pickTile()\x,pickTile()\y) = 0
			ForEach saveTile()
				If saveTile()\x = pickTile()\x And saveTile()\y = pickTile()\y
					If saveTile()\x = xDivide And saveTile()\y = yDivide
						xDivideKey = shopX		;Falls Trennlinie durch verschlossene Tür verläuft ...
						yDivideKey = shopY
						divideDoorIndex = a		;... Index merken
					EndIf
					DeleteElement(saveTile())
				EndIf
			Next
		Until ListSize(saveTile()) = #Null
	EndIf
	translateFloor()
	;}	

	;{ FINALIZE DIVISION
	progressBar(0,1)
	If xDivide And yDivide
		Repeat
			_EachActor(#isItemP,0)
				If actor()\subtype = #keyItem
					If (Not divideDoorIndex) Or (divideDoorIndex And actor()\flagDummy > divideDoorIndex)
						collisionMap(actor()\xDummy,actor()\yDummy) = 1
					EndIf
				EndIf
			_EndEach()
			collisionMap(xDivide,yDivide) = 1
			;Erster Teleporter
			CopyList(blackShoppingList(),saveTile())
			While ListSize(saveTile()) > #Null
				SelectElement(saveTile(),Random(ListSize(saveTile()),1)-1)
				shopX = saveTile()\x
				shopY = saveTile()\y
				If (getPath(shopX,shopY,xDivide,yDivide,#Null,#False) And Not(divideDoorIndex)) Or (getPath(shopX,shopY,xDivideKey,yDivideKey,#Null,#False) And divideDoorIndex)
					Break
				Else
					DeleteElement(saveTile())
				EndIf
			Wend
			If ListSize(saveTile()) = #Null
				xDivide = 0
				yDivide = 0
				Break
			EndIf
			deleteShopItem(0)
			xPortal(0) = shopX
			yPortal(0) = shopY
			;Erstes TeleTarget
			CopyList(whiteShoppingList(),saveTile())
			While ListSize(saveTile()) > #Null
				SelectElement(saveTile(),Random(ListSize(saveTile()),1)-1)
				shopX = saveTile()\x
				shopY = saveTile()\y
				If getPath(shopX,shopY,xDivide,yDivide,#Null,#False) And (Not getPath(shopX,shopY,xPortal(0),yPortal(0),#Null,#False))
					Break
				Else
					DeleteElement(saveTile())
				EndIf
			Wend
			If ListSize(saveTile()) = #Null
				xDivide = 0
				yDivide = 0
				Break
			EndIf
			deleteShopItem(255)
			xPortalTarget(0) = shopX
			yPortalTarget(0) = shopY
			;Zweiter Teleporter
			CopyList(blackShoppingList(),saveTile())
			While ListSize(saveTile()) > #Null
				SelectElement(saveTile(),Random(ListSize(saveTile()),1)-1)
				shopX = saveTile()\x
				shopY = saveTile()\y
				If getPath(shopX,shopY,xDivide,yDivide,#Null,#False) And (Not getPath(shopX,shopY,xPortal(0),yPortal(0),#Null,#False))
					Break
				Else
					DeleteElement(saveTile())
				EndIf
			Wend
			If ListSize(saveTile()) = #Null
				xDivide = 0
				yDivide = 0
				Break
			EndIf
			deleteShopItem(0)
			xPortal(1) = shopX
			yPortal(1) = shopY
			;Zweites TeleTarget
			CopyList(whiteShoppingList(),saveTile())
			While ListSize(saveTile()) > #Null
				SelectElement(saveTile(),Random(ListSize(saveTile()),1)-1)
				shopX = saveTile()\x
				shopY = saveTile()\y
				If getPath(shopX,shopY,xDivide,yDivide,#Null,#False) And (Not getPath(shopX,shopY,xPortal(1),yPortal(1),#Null,#False))
					Break
				Else
					DeleteElement(saveTile())
				EndIf
			Wend
			If ListSize(saveTile()) = #Null
				xDivide = 0
				yDivide = 0
				Break
			EndIf			
			deleteShopItem(255)
			xPortalTarget(1) = shopX
			yPortalTarget(1) = shopY
			;Dungeon trennen:
			floorMap(xDivide,yDivide) = 0
			translateFloor()
			Break
		ForEver
		If xDivide And yDivide
			For count = 0 To 1
				createTeleport(	#tPortal,dFloor,xPortal(count),yPortal(count),dFloor,xPortalTarget(count),yPortalTarget(count),#True,-1)
			Next
			If xDivideKey And yDivideKey
				_EachActor(#isItemP,0)
					If actor()\subtype = #keyItem And actor()\x = xDivideKey And actor()\y = yDivideKey
						DeleteElement(actor())
						Break
					EndIf
				_EndEach()
			EndIf
		Else
			;Restore Shopping Lists
			For count = 0 To 1
				If xPortal(count) And yPortal(count)
					AddElement(blackShoppingList())
					blackShoppingList()\x = xPortal(count)
					blackShoppingList()\y = yPortal(count)
					blackShoppingList()\value = floorMap(blackShoppingList()\x,blackShoppingList()\y)
				EndIf
				If xPortalTarget(count) And yPortalTarget(count)
					AddElement(whiteShoppingList())
					whiteShoppingList()\x = xPortal(count)
					whiteShoppingList()\y = yPortal(count)
					whiteShoppingList()\value = floorMap(whiteShoppingList()\x,whiteShoppingList()\y)
				EndIf
			Next
		EndIf
	EndIf
	;}

	;{ MAKE IT PRETTY
	
	;Türen
	progressBar(0,1)
	ForEach freeField()
		If freeField()\value = #doorIndex
			createDoor(#True,#regularDoor,0,0,freeField()\x,freeField()\y,0)
		EndIf
	Next
	;Türfarbe und Collision für verschlossene Türen anpassen
	progressBar(0,1)
	_EachActor(#isDoorP,0)
		If actor()\subtype = #regularDoor
			parentLoop = eachCount
			*thisActor = @actor()
			_EachActor(#isItemP,0)
				If actor()\subtype = #keyItem And actor()\xDummy = *thisActor\x And actor()\yDummy = *thisActor\y
					*thisActor\class = actor()\class
					*thisActor\collision = #pathCollision
					Break
				EndIf
			_EndEach()
			eachCount = parentLoop
		EndIf
	_EndEach()
	
	
	;Brazier
	progressBar(0,1)
	For count = 1 To 12	
		pickShopItem(0,#True)
		createBrazier(0,shopX,shopY)
	Next
	
	
	;Stein
	progressBar(0,1)
	count = dungeonSize/2
	count = limit(count,0,ListSize(blackShoppingList()))
	If count
		Dim placementMatrix(xMax,yMax)		
		For a = 1 To count
			ClearList(pickTile())
			ForEach blackShoppingList()
				legit = #True
				For dir = 1 To 8
					If placementMatrix(blackShoppingList()\x+xMod(dir),blackShoppingList()\y+yMod(dir)) = 1
						legit = #False
						Break
					EndIf
				Next
				If legit
					AddElement(pickTile())
					pickTile()\x = blackShoppingList()\x
					pickTile()\y = blackShoppingList()\y
				EndIf
			Next
			If ListSize(pickTile())
				SelectElement(pickTile(),Random(ListSize(pickTile()),1)-1)
				shopX = pickTile()\x
				shopY = pickTile()\y

				actorFactory(#True,#True,#False,#False,#False,#False,#False,#False,#False,#False,#False,#False,#False,
				             -1,#obstacleActor,#oStone,0,0,0,0,#aboveDepth,#defaultVisibility,#defaultCollision,#False,#False,#adjacentInteract,shopX,shopY,-1)
				placementMatrix(shopX,shopY) = 1
				
				deleteShopItem(0)
			Else
				Break
			EndIf
		Next
	EndIf
	
	
	;Säulen
	progressBar(0,1)
	count = ListSize(blackShoppingList())
	If count
 		For count = #firstRoomIndex To maxInstance
 			ClearList(saveTile())
 			Dim placementMatrix(xMax,yMax)		
 			;Regeln für offene Liste
 			_EachActor(#hasImageP,#Null)
 				If actor()\type = #obstacleActor
 					If actor()\subtype = #oStone Or actor()\subtype = #oBrazier
 						placementMatrix(actor()\x,actor()\y) = 1
 					EndIf
 				EndIf
 			_EndEach()
 ;			_EachActor(#isTriggerP,#Null)
 ;				If actor()\type = #teleportActor And actor()\subtype = #tPortal
; 					placementMatrix(actor()\x,actor()\y) = 1
 ;				EndIf
 ;			_EndEach()
 			;Auf offene Liste setzen
 			ForEach blackShoppingList()
 				If blackShoppingList()\value = count
 					legit = #True
 					For dir = 1 To 8
 						If placementMatrix(blackShoppingList()\x,blackShoppingList()\y-1) = 1
 							legit = #False
 							Break
 						EndIf
 					Next
 					If legit
 						AddElement(saveTile())
 						saveTile()\x = blackShoppingList()\x
 						saveTile()\y = blackShoppingList()\y
 					EndIf
 				EndIf
 			Next
 			Dim placementMatrix(xMax,yMax)
 			While ListSize(saveTile())	
				Repeat
					legit = #True
					SelectElement(saveTile(),Random(ListSize(saveTile()),1)-1)
					shopX = saveTile()\x
					shopY = saveTile()\y
					For dir = 5 To 8
						If placementMatrix(shopX+xMod(dir),shopY+yMod(dir)) = 1
							legit = #False
							Break
						EndIf
					Next
					DeleteElement(saveTile())
					If ListSize(saveTile()) = #Null
						Break 2
					EndIf
				Until legit
				
				deleteShopItem(0)
				actorFactory(#True,#False,#False,#False,#False,#False,#False,#False,#False,#False,#False,#False,#False,
				             -1,#obstacleActor,#oPillar,0,0,0,0,#aboveDepth,#defaultVisibility,#defaultCollision,#True,#False,#nullInteract,shopX,shopY,-1)
				placementMatrix(shopX,shopY) = 1
			Wend
			ClearList(pickTile())
			ForEach actor()
				If actor()\type = #obstacleActor And actor()\subtype = #oPillar And floorMap(actor()\x,actor()\y) = count
					AddElement(pickTile())
					pickTile()\x = actor()\x
					pickTile()\y = actor()\y
				EndIf
			Next
			countTiles = ListSize(pickTile())
			dice = bellCurveRoll(0,countTiles/2)
			While ListSize(pickTile()) > dice
				SelectElement(pickTile(),Random(ListSize(pickTile()),1)-1)
				_EachActor(#hasImageP,#Null)
					If actor()\type = #obstacleActor And actor()\subtype = #oPillar
						If actor()\x = pickTile()\x And actor()\y = pickTile()\y
							placementMatrix(actor()\x,actor()\y) = 0
							markForKill(@actor())
							Break
						EndIf
					EndIf
				_EndEach()
				restoreShopItem(0,pickTile()\x,pickTile()\y)
				DeleteElement(pickTile())
			Wend
		Next
		;Maximal 2 Säulen nebeneinander
		Dim placementMatrix(xMax,yMax)
		_EachActor(#hasImageP,#Null)
			If actor()\type = #obstacleActor And actor()\subtype = #oPillar
				placementMatrix(actor()\x,actor()\y) = 1
			EndIf
		_EndEach()
		For x = 2 To xMax-2
			For y = 2 To yMax-2
				If placementMatrix(x,y) And placementMatrix(x,y+1) And placementMatrix(x,y+2)
					yShift = y
					dice = 0
					If (y < yMax-2) And placementMatrix(x,y+3)
						yShift = y+Random(1)
						dice = Random(1)
					EndIf
					Repeat
						placementMatrix(x,yShift) = 2
						yShift+1
					Until placementMatrix(x,yShift+dice) = 0
				EndIf
			Next
		Next
		For y = 2 To yMax-2
			For x = 2 To xMax-2
				If placementMatrix(x,y) And placementMatrix(x+1,y) And placementMatrix(x+2,y)
					xShift = x
					dice = 0
					If (x < xMax-2) And placementMatrix(x+3,y)
						xShift = x+Random(1)
						dice = Random(1)
					EndIf
					Repeat
						placementMatrix(xShift,y) = 2
						xShift+1
					Until placementMatrix(xShift+dice,y) = 0
				EndIf
			Next
		Next		
		
		_EachActor(#hasImageP,#Null)
			If actor()\type = #obstacleActor And actor()\subtype = #oPillar And placementMatrix(actor()\x,actor()\y) = 2
;				restoreShopItem(0,actor()\x,actor()\y)			
				floorMap(actor()\x,actor()\y) = 0
				markForKill(@actor())
			EndIf
		_EndEach()
		checkKillMark()	
		translateFloor()
	EndIf	
	
	;Wall Pattern
	count = 0
	xLoc = 0
	For y = 1 To yMax-1
		For x = 1 To xMax -1
			If floorMap(x,y) = 0 And floorMap(x,y+1) > #doorIndex And floorMap(x-1,y) = 0 And floorMap(x+1,y) = 0
				If xLoc = 0	:	xLoc = x : EndIf
				If xLoc
					count +1
				EndIf
			Else
				count -1
				If count >= 2 And Random(4) > 1
					For xShift = xLoc To xLoc+count
						d = 1
						If xShift = xLoc		:	d = 0 : EndIf
						If xShift = xLoc+count	:	d = 2 : EndIf
						actorFactory(#True,#False,#False,#False,#False,#False,#False,#False,#False,#False,#False,#False,#False,
						             0,#patternActor,#wallPattern,0,d,0,0,#patternDepth,#defaultVisibility,#nullCollision,#False,#False,#nullInteract,xShift,y,-1)
					Next
				EndIf
				xLoc = 0
				count = 0
			EndIf
		Next
	Next
	;}	
	
	translateFloor()	
	distributeMonsters(#False)
	distributeItems()
	progressBar(0,500)
	If wizmode(#wizShowOverview)
		previewDungeon(#True)
	EndIf
	shuffleDelay = 1000
EndProcedure






Procedure floodFillDungeon()
	Define x, y
	Define count
	Define legit
	Define noError
	Define dir
	
	progressBar(0,1)
	;{ DISTRIBUTE ROOM IDENTY
	For x = 1 To xMax-1
		For y = 1 To yMax-1
			If floorMap(x,y) > #doorIndex
				floorMap(x,y) = xMax*yMax
			EndIf
		Next
	Next
	translateFloor()
	count = #firstRoomIndex-1
	Repeat
		legit = #True
		ForEach freeField()
			If floorMap(freeField()\x,freeField()\y) = xMax*yMax
				count +1
				floorMap(freeField()\x,freeField()\y) = count
				legit = #False
				Break
			EndIf
		Next
		If Not legit
			Repeat
				noError = #True
				ForEach freeField()
					If floorMap(freeField()\x,freeField()\y) = count
						For dir = 1 To 4
							If floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) <> count And floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) > #doorIndex
								floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) = count
								noError = #False
							EndIf
						Next
					EndIf
				Next
			Until noError
		EndIf
	Until legit
	maxInstance = count
	translateFloor()
	;}
	Delay(1)
EndProcedure


Procedure detectDeadEnd(x,y)
	Define count
	Define dir
	
	count = 0
	For dir = 1 To 4
		If floorMap(x+xMod(dir),y+yMod(dir)) > #doorIndex
			count +1
		EndIf
	Next
	Delay(1)
	If count = 1
		ProcedureReturn #True
	EndIf
EndProcedure


Procedure createDoor(initializeDoorTile,subtype,class,sort,x,y,status)
	Define doorCollision
	
	If initializeDoorTile
		If gameRunning
			baseMap(x,y) = editBaseMap(x,y)
		EndIf
		collisionMap(x,y) = #nullCollision
	EndIf
	

	Select status
		Case 0
			doorCollision = #pathCollision
			If subtype = #regularDoor And class = 0
				doorCollision = #removableCollision
			EndIf
			
			actorFactory(#True,#True,#True,#False,#False,#False,#False,#False,#False,#False,#False,#False,#False,
							-1,#doorActor,subtype,class,sort,0,status,#hideItemDepth,#defaultVisibility,doorCollision,#True,#True,#adjacentInteract,x,y,-1)
		Case 1
			actorFactory(#True,#True,#True,#False,#False,#False,#False,#False,#False,#False,#False,#False,#False,
							-1,#doorActor,subtype,class,sort,0,status,#aboveDepth,#defaultVisibility,#nullCollision,#False,#False,#adjacentInteract,x,y,-1)
	EndSelect
EndProcedure


Procedure createTeleport(appearance,dFloor0,x0,y0,dFloor1,x1,y1,active,charges)
	Select appearance
		Case #tInvisible
			actorFactory(#False,#False,#False,#False,#False,#False,#False,#False,#False,#False,#True,#False,#False,
							-1,#teleportActor,appearance,0,0,0,0,#aboveDepth,#nullVisibility,#nullCollision,#False,#False,#nullInteract,x0,y0,-1)
		Case #tPortal
			actorFactory(#True,#False,#False,#False,#True,#False,#False,#False,#False,#False,#True,#False,#False,
							-1,#teleportActor,appearance,0,0,0,0,#aboveDepth,#defaultVisibility,#nullCollision,#False,#False,#nullInteract,x0,y0,-1)
			actorToAnimation(0,200,4,ElapsedMilliseconds(),150,0,0)
	EndSelect
	
	AddElement(teleport())
	teleport()\dFloor[0] = dFloor0
	teleport()\x[0] = x0
	teleport()\y[0] = y0
	teleport()\dFloor[1] = dFloor1
	teleport()\x[1] = x1
	teleport()\y[1] = y1
	teleport()\active = active
	teleport()\charges = charges
EndProcedure	
	

Procedure pickShopItem(listColor,pickAndDelete)
	shopX = 0
	shopY = 0
	
	If listColor = 0
		SelectElement(blackShoppingList(),Random(ListSize(blackShoppingList()),1)-1)
		shopX = blackShoppingList()\x
		shopY = blackShoppingList()\y
	Else
		SelectElement(whiteShoppingList(),Random(ListSize(whiteShoppingList()),1)-1)
		shopX = whiteShoppingList()\x
		shopY = whiteShoppingList()\y
	EndIf
	If pickAndDelete
		deleteShopItem(listColor)
	EndIf
EndProcedure


Procedure restoreShopItem(listColor,x,y)
	If listColor = 0
		AddElement(blackShoppingList())
		blackShoppingList()\x = x
		blackShoppingList()\y = y
		blackShoppingList()\value = floorMap(x,y)
	Else
		AddElement(whiteShoppingList())
		whiteShoppingList()\x = x
		whiteShoppingList()\y = y
		whiteShoppingList()\value = floorMap(x,y)
	EndIf
EndProcedure


Procedure deleteShopItem(listColor)
	If listColor = 0
		ForEach blackShoppingList()
			If blackShoppingList()\x = shopX And blackShoppingList()\y = shopY
				DeleteElement(blackShoppingList())
				Break
			EndIf
		Next
	Else
		ForEach whiteShoppingList()
			If whiteShoppingList()\x = shopX And whiteShoppingList()\y = shopY
				DeleteElement(whiteShoppingList())
				Break
			EndIf
		Next
	EndIf
EndProcedure


Procedure fixDeadEnds()
	Define noError
	Define count
	Define dir
	
	progressBar(0,1)
	Repeat
		noError = #True
		;DeadEnd - Removal
		ForEach freeField()
			count = 0
			For dir = 1 To 4
				If floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) = 0
					count +1
				EndIf
			Next
			If count > 2
				floorMap(freeField()\x,freeField()\y) = 0
				noError = #False
			EndIf
		Next
		translateFloor()
	Until noError
	Delay(1)
EndProcedure


Procedure linkRooms()
	Define x, y
	Define dir
	Define currentIndex
	
	ClearList(pointXY())
	If floorMap(pickTile()\x,pickTile()\y) = #doorIndex
		;Horizontal
		For x = pickTile()\x To pickTile()\x + 10
			If (floorMap(x,pickTile()\y) = 0 Or floorMap(x,pickTile()\y) = #doorIndex) And floorMap(x,pickTile()\y-1) > #doorIndex And floorMap(x,pickTile()\y+1) > #doorIndex
				AddElement(pointXY())
				pointXY()\x = x
				pointXY()\y = pickTile()\y
			Else
				Break
			EndIf
		Next
		For x = pickTile()\x To pickTile()\x - 10 Step -1
			If (floorMap(x,pickTile()\y) = 0 Or floorMap(x,pickTile()\y) = #doorIndex) And floorMap(x,pickTile()\y-1) > #doorIndex And floorMap(x,pickTile()\y+1) > #doorIndex
				AddElement(pointXY())
				pointXY()\x = x
				pointXY()\y = pickTile()\y
			Else
				Break
			EndIf
		Next

	;Vertikal
		For y = pickTile()\y To pickTile()\y + 10
			If (floorMap(pickTile()\x,y) = 0 Or floorMap(pickTile()\x,y) = #doorIndex) And floorMap(pickTile()\x-1,y) > #doorIndex And floorMap(pickTile()\x+1,y) > #doorIndex
				AddElement(pointXY())
				pointXY()\x = pickTile()\x
				pointXY()\y = y
			Else
				Break
			EndIf
		Next
		For y = pickTile()\y To pickTile()\y - 10 Step -1
			If (floorMap(pickTile()\x,y) = 0 Or floorMap(pickTile()\x,y) = #doorIndex) And floorMap(pickTile()\x-1,y) > #doorIndex And floorMap(pickTile()\x+1,y) > #doorIndex
				AddElement(pointXY())
				pointXY()\x = pickTile()\x
				pointXY()\y = y
			Else
				Break
			EndIf
		Next
	EndIf
	
	If ListSize(pointXY()) > 1
		For dir = 1 To 4
			currentIndex = floorMap(pointXY()\x+xMod(dir),pointXY()\y+yMod(dir))
			If currentIndex > #doorIndex
				Break
			EndIf
		Next
		ForEach pointXY()
			floorMap(pointXY()\x,pointXY()\y) = currentIndex
		Next
		translateFloor()	
	EndIf
	Delay(1)
EndProcedure


Procedure homogenizeRoomIndex()
	Define noError
	Define dir
	Define currentIndex, lowerIndex
	Repeat
		noError = #True
		ForEach freeField()
			If freeField()\value > #doorIndex
				For dir = 1 To 4
					If floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) > #doorIndex
						If floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir)) <> freeField()\value
							currentIndex = floorMap(freeField()\x+xMod(dir),freeField()\y+yMod(dir))
							lowerIndex = freeField()\value
							noError = #False
							If lowerIndex > currentIndex
								Swap lowerIndex,currentIndex
							EndIf
							If Mod(lowerIndex,2) = 0 And Mod(currentIndex,2) <> 0
								Swap lowerIndex,currentIndex
							EndIf
							
							Break 2
						EndIf
					EndIf
				Next
			EndIf
		Next
		
		If noError = #False
			ForEach freeField()
				If floorMap(freeField()\x,freeField()\y) = currentIndex
					floorMap(freeField()\x,freeField()\y) = lowerIndex
				EndIf
			Next
			translateFloor()

		EndIf
	Until noError
	Delay(1)
EndProcedure


Procedure progressBar(resetBar,progressDelay)
	Static xBarMax
	Define x = 100
	Define y = 100
	Define yHeight = 75
	Define xBarLength = #xRes-(x*2)
	Define xBarMultiplier = xBarLength/100
	Static xBarIndex
	If resetBar
		xBarIndex = 0
		xBarMax = resetBar
	Else
		xBarIndex +1
	EndIf
	
	ClearScreen(color(#cBlack))
	If StartDrawing(ScreenOutput())
		
		If progressDelay = 500
			Box(x,y,xBarLength,yHeight,color(#cBlood))
		Else
			Box(x,y,(((xBarIndex*100)/xBarMax)*xBarMultiplier),yHeight,color(#cBlood))
		EndIf
		_DMode0()
		Box(x,y,xBarLength,yHeight,color(#cLight))
		StopDrawing()
	EndIf
	FlipBuffers()
	
	If screen
		WaitWindowEvent(1)
	EndIf	
	If progressDelay
		Delay(progressDelay)
	EndIf
EndProcedure


Procedure previewDungeon(waitKey)
	Define count, c
	Define x, y
	Define eachCount
	Define screenSPR
	
	For createSize = 10 To 1 Step -1
		If createSize*yMax <= #yRes And createSize*xMax <= #xRes
			Break
		EndIf
	Next
	
	Dim roomColor(maxInstance)
	count = Random(20,1)
	For c = 0 To ArraySize(roomColor())
		roomColor(c) = color(count)
		count +1
		If count > 20 : count = 1 : EndIf
	Next	
	
	ClearScreen(RGB(0,0,0))	
	If StartDrawing(ScreenOutput())
		_DMode1()
		ForEach freeField()
			If freeField()\value > #doorIndex
				;				roomColor(0) = RGB(255,255,255)
				;				roomColor(0) = color(Random(21,1))
				;				Box(freeField()\x*createSize,freeField()\y*createSize,createSize,createSize,roomColor(0))
				Box(freeField()\x*createSize,freeField()\y*createSize,createSize,createSize,roomColor(freeField()\value))
			EndIf
		Next
		
		_EachActor(#isDoorP,0)
			_DMode1()
			Box(actor()\x*createSize,actor()\y*createSize,createSize,createSize,lockedColor(actor()\class))
			_DMode0()
			Box((actor()\x*createSize)-1,(actor()\y*createSize)-1,createSize+2,createSize+2,color(#cWhite))
		_EndEach()
		
		_EachActor(#isItemP,0)
			If actor()\subtype = #keyItem
				_DMode1()
				;				Box(actor()\x*createSize,actor()\y*createSize,createSize,createSize,lockedColor(actor()\class))
				_DMode0()
				;				Box(actor()\x*createSize,actor()\y*createSize,createSize,createSize,color(#cBlack))
			EndIf
		_EndEach()
		
		ForEach actor()
			If actor()\type = #obstacleActor And actor()\subtype = #oPillar
				_DMode1()
				Circle((actor()\x*createSize)+(createSize/2),(actor()\y*createSize)+(createSize/2),(createSize/2),color(#cStone))
				_DMode0()
				Circle((actor()\x*createSize)+(createSize/2),(actor()\y*createSize)+(createSize/2),(createSize/2),RGB(0,0,0))	
			EndIf
		Next
		
		
		
		_DMode1()
		;		Box(xDivide*createSize,yDivide*createSize,createSize,createSize,RGB(255,255,0))
		ForEach teleport()
			If teleport()\dFloor[0] = dFloor
				Box(teleport()\x[0]*createSize,teleport()\y[0]*createSize,createSize,createSize,RGB(0,225,225))	
				LineXY(teleport()\x[1]*createSize,teleport()\y[1]*createSize,(teleport()\x[1]*createSize)+createSize,(teleport()\y[1]*createSize)+createSize,RGB(0,0,0))
				LineXY(teleport()\x[1]*createSize,(teleport()\y[1]*createSize)+createSize,(teleport()\x[1]*createSize)+createSize,teleport()\y[1]*createSize,RGB(0,0,0))
			EndIf
		Next
		;		_DMode0()
		;		ForEach actor()
		;			If actor()\type = #obstacleActor
		;				Box(actor()\x*createSize,actor()\y*createSize,createSize,createSize,RGB(0,0,0))
		;			EndIf
		;		Next
		
		_DMode1()
		Circle((xPlayer*createSize)+(createSize/2),(yPlayer*createSize)+(createSize/2),(createSize/2),RGB(0,255,0))
		_DMode0()
		Circle((xPlayer*createSize)+(createSize/2),(yPlayer*createSize)+(createSize/2),(createSize/2),RGB(0,0,0))	
		
		;Box((xMax/3)*createSize,(yMax/3)*createSize,((xMax-(xMax/3))-(xMax/3))*createSize,((yMax-(yMax/3))-(yMax/3))*createSize,color(#cWhite))
		
		DrawingFont(FontID(font(2))) 
		DrawText(#xRes-260,#yRes-30,"Floor: "+Str(dFloor)+" ("+Str(cs1)+","+Str(cs2)+")",RGB(255,255,255))		
		


		StopDrawing()
	EndIf
	screenSPR = GrabSprite(#PB_Any,0,0,#xRes,#yRes)
	
	Repeat
		x = limit(MouseX()/createSize,0,xMax)
		y = limit(MouseY()/createSize,0,yMax)		
		If floorMap(x,y) < #firstRoomIndex
			x = 0
			y = 0
		EndIf
		
		ClearScreen(RGB(0,0,0))	
		DisplaySprite(screenSPR,0,0)
		If wizMode(#wizSelectStart)
			If StartDrawing(ScreenOutput())
				Circle(MouseX(),MouseY(),(createSize/2),RGB(255,0,0))
				If floorMap(x,y) >= #firstRoomIndex
					DrawingFont(FontID(font(2))) 
					DrawText(#xRes-60,#yRes-60,Str(x)+","+Str(y),RGB(255,255,255))
				EndIf
				StopDrawing()
			EndIf
		EndIf
		FlipBuffers()
		
		If screen
			WaitWindowEvent(1)
		EndIf
		Delay(1)
		
		ExamineKeyboard()
		ExamineMouse()
		
		If KeyboardReleased(#PB_Key_Escape)
			End
		EndIf
		
		
		If MouseButton(#PB_MouseButton_Left) And x And y
			Break
		EndIf
		If KeyboardReleased(#PB_Key_Return) Or waitKey = #False
			x = 0
			y = 0
			Break
		EndIf
		
	ForEver
	FreeSprite(screenSPR)
	screenSPR = #Null

	If x And y And wizMode(#wizSelectStart)
		collisionMap(xPlayer,yPlayer) - *player\collision
		enterTile(*player,x,y)
	EndIf
EndProcedure


Procedure carveRoom(xLoc,yLoc,xSize,ySize,index)
	Define x, y
		
	For x = xLoc To xLoc+xSize-1
		For y = yLoc To yLoc+ySize-1
			floorMap(x,y) = index
		Next
	Next
	
	dungeonFill + (xSize*ySize)
	Delay(1)
EndProcedure


Procedure translateFloor()
	Define x,y
	
	Dim bresenRef(xMax,yMax)
	Dim collisionMap(xMax,yMax)
	Dim blockShootMap(xMax,yMax)
	
	For x = 0 To xMax
		For y = 0 To yMax
			If floorMap(x,y) = 0
				blockShootMap(x,y) = #True
				collisionMap(x,y) = #permCollision
				bresenRef(x,y) = #True
			EndIf
		Next
	Next
	
	ForEach actor()
		If actor()\type = #doorActor
			bresenRef(actor()\x,actor()\y) = #False
			collisionMap(actor()\x,actor()\y) = #nullCollision
			blockShootMap(actor()\x,actor()\y) = #False
		EndIf
	Next
	ForEach actor()
		bresenRef(actor()\x,actor()\y) + actor()\blockLoS
		collisionMap(actor()\x,actor()\y) + actor()\collision
		blockShootMap(actor()\x,actor()\y) + actor()\blockShoot
	Next

	ClearList(freeField())
	For x = 1 To xMax-1
		For y = 1 To yMax-1
			If collisionMap(x,y) < #permCollision
				AddElement(freeField())
				freeField()\x = x
				freeField()\y = y
				freeField()\value = floorMap(x,y)
			EndIf
		Next
	Next
	Delay(1)
EndProcedure



Procedure createBrazier(status,x,y)
	Define canInteract = #True
	Define interactType = #adjacentInteract
	If status = 1
		canInteract = #False
		interactType = #nullInteract
	EndIf
	Define index
	
	actorFactory(#True,canInteract,#False,#False,#False,#False,#False,#False,#False,#False,#False,#False,#False,
	             -1,#obstacleActor,#oBrazier,0,0,0,status,#aboveDepth,#defaultVisibility,#defaultCollision,#True,#False,interactType,x,y,-1)
	
	If status = 1
		index = actor()\index
		actorFactory(#True,#False,#False,#False,#True,#False,#False,#False,#True,#False,#False,#False,#False,
		            index,#animationActor,#brazierAnim,0,0,0,0,#aboveDepth+1,#defaultVisibility,#nullCollision,#False,#False,#nullInteract,x,y,-1)
		actorToAnimation(0,225,3,ElapsedMilliseconds(),100,0,0)
	EndIf
EndProcedure


Procedure distributeMonsters(onlyPlayer)
	Define m
	Define x, y
	Define listColor
	Define nothingFound
	Define legit
	Define dice
	

	;Player
	If Not *player
		createMonster(0,0,xPlayer,yPlayer)
	Else
		enterTile(*player,xPlayer,yPlayer)
		If onlyPlayer	:	ProcedureReturn #False	:	EndIf
	EndIf

	;Monsters
	progressBar(0,1)
	ClearList(pickTile())
	ForEach blackShoppingList()
		_Dist(xPlayer,yPlayer,blackShoppingList()\x,blackShoppingList()\y)
		If distance > #lineOfSightMax
			AddElement(pickTile())
			pickTile()\x = blackShoppingList()\x
			pickTile()\y = blackShoppingList()\y
			pickTile()\value = 0
		EndIf
	Next
	ForEach whiteShoppingList()
		_Dist(xPlayer,yPlayer,whiteShoppingList()\x,whiteShoppingList()\y)
		If distance > #lineOfSightMax
			AddElement(pickTile())
			pickTile()\x = whiteShoppingList()\x
			pickTile()\y = whiteShoppingList()\y
			pickTile()\value = 255
		EndIf
	Next
	monsterMax = limit(monsterMax,0,ListSize(pickTile()) )
	If monsterMax > 0
		For m = 1 To monsterMax
			SelectElement(pickTile(),Random(ListSize(pickTile()),1)-1)
			shopX = pickTile()\x
			shopY = pickTile()\y
			dice = Random(#monsterClassMax)
			If dice = 2
				dice = Random(#monsterClassMax)
			EndIf
			createMonster(1,dice,shopX,shopY)
			Delay(1)
	;		deleteShopItem(pickTile()\value)
			DeleteElement(pickTile())
		Next
	EndIf
EndProcedure


Procedure distributeItems()
	Define i
	Define x, y
	Define dice

	progressBar(0,1)
	If itemMax > 0
		For i = 1 To itemMax
			pickShopItem(Random(1)*255,#False)
			createItem(#equipableItem,#meleeItem,Random(#meleeWeaponMax),0,0,#itemDepth,#selfInteract,0,0)
			dropItem(@actor(),shopX,shopY)
		Next
		For i = 1 To itemMax/2
;			pickShopItem(255,#False)
;			createItem(#equipableItem,#shieldItem,Random(1),0,0,0,0)
;			dropItem(@actor(),shopX,shopY)
		Next
;		pickShopItem(255,#False)
;		createItem(#equipableItem,#rangedItem,0,0,0,0,0)
;		dropItem(@actor(),shopX,shopY)
		For i = 1 To itemMax*2
;			pickShopItem(255,#False)
;			createItem(#equipableItem,#ammoItem,0,0,0,0,0)
;			dropItem(@actor(),shopX,shopY)
		Next

		For i = 1 To itemMax
			pickShopItem(Random(1)*255,#False)
			createItem(#consumableItem,#foodClass,Random(#foodMax),0,0,#itemDepth,#selfInteract,0,0)
			dropItem(@actor(),shopX,shopY)
		Next
	EndIf
	
	;Map
	For i = 1 To 2
		pickShopItem(Random(1)*255,#False)
		createItem(#staticItem,#mapItem,i,0,0,#itemDepth,#selfInteract,0,0)
		If wizMode(#wizGiveMap)
			shopX = *player\x
			shopY = *player\y
		EndIf
		dropItem(@actor(),shopX,shopY)
	Next
	
	
	Delay(1)
EndProcedure	
; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 69
; FirstLine = 48
; Folding = -4zf0---
; Markers = 1223
; EnableXP