﻿Macro _MyFlip()
	If IsScreenActive()
		FlipBuffers()
	EndIf
	Delay(1)
	If screen
		WaitWindowEvent(1)
	EndIf
EndMacro



Macro _Display()
	DisableDebugger
	ExamineMouse()
	ExamineKeyboard()
	processTimer()
	ClearScreen(color(#cBlack))
	If Not jobDescription
		drawStuff()
		drawStatusBar()
	EndIf
	EnableDebugger
EndMacro


Macro _LoadImg(path)
	If IsImage(pic)
		FreeImage(pic)
	EndIf
	pic = LoadImage(#PB_Any,"RESSOURCES/"+path)
EndMacro
		

Macro _DMode0()
	DrawingMode(#PB_2DDrawing_Outlined)
EndMacro


Macro _DMode1()
	DrawingMode(#PB_2DDrawing_Default)
EndMacro


Macro _TText()
	DrawingMode(#PB_2DDrawing_Transparent)
EndMacro


Macro _NewSprite(type,subtype,class,sort,quality,status,animFrame)
	If Not IsSprite(actorSPR(type,subtype,class,sort,quality,status,animFrame))
		actorSPR(type,subtype,class,sort,quality,status,animFrame) = CreateSprite(#PB_Any,#xTileSize,#yTileSize)
		If StartDrawing(SpriteOutput(actorSPR(type,subtype,class,sort,quality,status,animFrame)))
EndMacro
	

Macro _EndSprite()
			StopDrawing()
		EndIf
	EndIf
EndMacro


Macro _OffsetX()
	((xMaxView-xViewCenter)*#xTileSize)+xMargin
EndMacro


Macro _OffsetY()
	((yMaxView-yViewCenter)*#yTileSize)+yMargin
EndMacro


Macro _Dist(x0,y0,x1,y1)
	distance = Sqr(((x0-x1)*(x0-x1)) + ((y0-y1)*(y0-y1)))
EndMacro


Macro _MonCon(mc)
	monsterConst(*origin\subtype,*origin\class,mc)
EndMacro


Macro _ReadMC(mc)
	monsterConst(monsterSubtype,monsterClass,mc)
EndMacro


Macro _ReadMF(mc)
	monsterFloat(monsterSubtype,monsterClass,mc)
EndMacro


Macro _EachActor(pointer,skipThis)
	For eachCount = 1 To actorCounter(pointer)
		If *actorPointer(pointer,eachCount)
			ChangeCurrentElement(actor(),*actorPointer(pointer,eachCount))
			If actor()\hp And Not actor()\ident[skipThis]
EndMacro
		

Macro _EndEach()
			EndIf
		EndIf
	Next
EndMacro


Macro _DebugActor()
	If *debug
		Debug ""+*debug\type+","+*debug\subtype+","+*debug\class+","+*debug\status+"  ("+*debug\x+","+*debug\y+")   Index: "+*debug\index
	EndIf
EndMacro
; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 20
; FirstLine = 17
; Folding = ---
; EnableXP